from visitor import Visitor

'''

Genera un archivo en formato XMI aplicando el patrón Visitor
'''


class XMIVisitor(Visitor):

    def __init__(self):
        self.indent = 0
        self.doc = None

    def visit_User(self, node):
        self.doc = '<cdsl:User username="{}">'.format(node.username)
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</cdsl:User>'])
        return self.doc

    def visit_City(self, node):
        self.doc = '\n'.join([self.doc, '<{0} name="{1}" country="{2}">'\
                             .format(node.edge_name, node.name, node.country)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Map(self, node):
        self.doc = '\n'.join([self.doc, '<{0} map_type="{1}" zoom="{2}" radius="{3}" coordinates="{4}">'\
                             .format(node.edge_name, node.map_type.upper() ,node.zoom, node.radius, node.coordinates)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Alert(self, node):
        self.doc = '\n'.join([self.doc, '<{0} timestamp="{1}" alert_type="{2}" description="{3}">'\
                             .format(node.edge_name, node.timestamp, node.alert_type, node.description)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Object(self, node):
        self.doc = '\n'.join([self.doc, '<{0} name="{1}" description="{2}" danger_level="{3}" object_type="{4}">'\
                             .format(node.edge_name, node.name, node.description, node.danger_level, node.object_type)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Service(self, node):
        self.doc = '\n'.join([self.doc, '<{0} service_type="{1}">'.format(node.edge_name, node.service_type)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Tweet(self, node):
        self.doc = '\n'.join([self.doc, '<{0} text="{1}">'.format(node.edge_name, node.text)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Geolocation(self, node):
        self.doc = '\n'.join([self.doc, '<{0} coordinates="{1}">'.format(node.edge_name, \
                        node.coordinates)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Video(self, node):
        self.doc = '\n'.join([self.doc, '<{0} url="{1}">'.format(node.edge_name, node.url)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Image(self, node):
        self.doc = '\n'.join([self.doc, '<{0} url="{1}">'.format(node.edge_name, node.url)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])

    def visit_Sensor(self, node):
        self.doc = '\n'.join([self.doc, '<{0} sensor_type="{1}" value="{2}">'.format(node.edge_name, node.sensor_type, node.value)])
        for child in node.children:
            self.visit(child)
        self.doc = '\n'.join([self.doc, '</{0}>'.format(node.edge_name)])