from business.parse_xml.parse_xml import read_xml

'''

Clase que construye el árbol en memoria a partir del XML de origen obtenido del framework 

'''

edges = {
        ('User', 'City'): 'city',
        ('User', 'Alert'): 'alert',
        ('Alert', 'Map'): 'map',
        ('Alert', 'Service'): 'service',
        ('Alert', 'Object'): 'object',
        ('Object', 'Sensor'): 'data_object',
        ('Object', 'Tweet'): 'data_object',
        ('Object', 'Geolocation'): 'data_object',
        ('Object', 'Video'): 'data_object',
        ('Object', 'Image'): 'data_object',
        ('Object', 'Sensor'): 'data_object',
        ('Alert', 'Tweet'): 'data_alert',
        ('Alert', 'Geolocation'): 'data_alert',
        ('Alert', 'Video'): 'data_alert',
        ('Alert', 'Image'): 'data_alert',
        ('Alert', 'Sensor'): 'data_alert',
}


def build(xml, username):
    nodes, edges = read_xml(xml, username)
    root = nodes[0]
    add_node(root, nodes, edges)
    return root


def add_node(root, nodes, edges):
    [root.add_child(find_node(root, nodes, edge.target)) for edge in edges if edge.source == root.id]
    [add_node(child, nodes, edges) for child in root.children]


def find_node(root, nodes, target):
    node = [node for node in nodes if node.id == target][0]
    try:
        edge_name = edges[type(root).__name__, type(node).__name__]
    except KeyError:
        edge_name = type(node).__name__
    node.edge_name = edge_name if edge_name is not None else type(node).__name__
    return node



