from persistence.persistence_factory import PersistenceFactory

'''
Operaciones de persistencia de datos para las incidencias que se graban en BDD

'''

def save(json):
    incidences = PersistenceFactory().incidences()
    return incidences.save_incidence(json)


def save_html_representation(id, html):
    incidences = PersistenceFactory().incidences()
    incidences.save_html_incidence(id, html)


def save_comment(alert, username, comment):
    incidences = PersistenceFactory().incidences()
    incidences.save_comment(alert, username, comment)


def get_alert_html(id):
    incidences = PersistenceFactory().incidences()
    return incidences.get_html_representation(id)


def get_alert_comments(id):
    incidences = PersistenceFactory().incidences()
    return incidences.get_alert_comments(id)


def get_alert_map(id):
    incidences = PersistenceFactory().incidences()
    return incidences.get_alert_map(id)


def get_all():
    incidences = PersistenceFactory().incidences()
    return incidences.get_all_incidences()


def get_all_alert_type():
    incidences = PersistenceFactory().incidences()
    return incidences.get_all_alert_types()


def get_all_danger_level():
    incidences = PersistenceFactory().incidences()
    return incidences.get_all_danger_level()


def filter_alerts(city, alert, damage):
    incidences = PersistenceFactory().incidences()
    return incidences.filter_alerts_by_criteria(city, alert, damage)