import pymongo
from persistence.users import User
from persistence.incidences import Incidence
from persistence.cities import City


class PersistenceFactory:

    def __init__(self):
        self.database = pymongo.MongoClient("mongodb://localhost:27017/")["crowdsl"]

    def users(self):
        return User(self.database)

    def incidences(self):
        return Incidence(self.database)

    def cities(self):
        return City(self.database)